if(!isObject(GunGameOptionsMenu))
	exec("./GunGameOptionsMenu.gui");

function clientCmdOpenGunGame() {
	if(GunGameOptionsMenu.isAwake())
		return;
	canvas.pushDialog(GunGameOptionsMenu);
}

function GunGameOptionsMenu::onWake(%this) {
	firstTimeGGOM(%this);
	refreshWeaponList(("GGO_Knife").getID());
	refreshWeaponList(("GGO_Grenade").getID());
	refreshWeaponList();
	refreshProfileList();
}

//Thanks to Space Guy for this function.
function refreshWeaponList(%list) {
	%gui = ("GunGameOptionsMenu").getID();
	if(%list !$= "") {
		if(%list.getValue() $= "")
			%temp = "NONE";
		else
			%temp = %list.getValue();
		%list.clear();
		if(DatablockGroup.getCount() > 2)
			%group = DatablockGroup;
		else
			%group = ServerConnection;
		%count = %group.getCount();
		for(%c=0;%c<%count;%c++) {
			%w = %group.getObject(%c);
			if(%w.getClassName() $= "ItemData" && %w.uiName !$= "") {
				%list.add(%w.uiName,%w.getID());
				%list.itemID[%w.uiName] = %w.getID();
			}
		}
		%list.sort();
		%list.addFront("NONE",0);
		%list.setValue(%temp);
	}
	else {
		for(%i=1;%i<=%gui.levelAmount;%i++) {
			%list = ("GGO_Level" @ %i).getID();
			%temp[%i] = %list.getValue();
			if(%temp[%i] $= "")
				%temp[%i] = "NONE";
			%list.clear();
		}
		if(DatablockGroup.getCount() > 2)
			%group = DatablockGroup;
		else
			%group = ServerConnection;
		%count = %group.getCount();
		for(%c=0;%c<%count;%c++) {
			%w = %group.getObject(%c);
			if(%w.getClassName() $= "ItemData" && %w.uiName !$= "") {
				for(%i=1;%i<=%gui.levelAmount;%i++) {
					("GGO_Level" @ %i).add(%w.uiName,%w.getID());
					("GGO_Level" @ %i).itemID[%w.uiName] = %w.getID();
				}
			}
		}
		for(%i=1;%i<=%gui.levelAmount;%i++){
			("GGO_Level" @ %i).sort();
			("GGO_Level" @ %i).addFront("NONE",0);
			("GGO_Level" @ %i).setValue(%temp[%i]);
		}
	}
}

function firstTimeGGOM(%gui) {
	if(%gui.firstTime)
		return;
	%winningMethod = ("GGO_WinningMethod").getID();
	%gui.levelAmount = 1;
	%gui.firstTime = 1;
	%levelCount = 2;
	for(%i=2;%i<16;%i++) {
		addGunGameLevel();
		%level = ("GGO_Level" @ %i @ "Level").getID();
		%level.setValue(%levelCount);
		%levelCount += 2;
	}
	%winningMethod.add("First Kill",0);
	%winningMethod.add("Point Limit",1);
	%winningMethod.setValue("First Kill");
}

function addGunGameLevel() {
	%gui = ("GunGameOptionsMenu").getID();
	if(%gui.levelAmount > 98)
		return;
	%gui.levelAmount++;
	("GGO_LevelSwatch").resize(1,1,205,(27+(30*(%gui.levelAmount-1))));
	%levelName = new GuiMLTextCtrl(("GGO_Level" @ %gui.levelAmount @ "Name")) {
		profile = "GuiMLTextProfile";
        horizSizing = "right";
        vertSizing = "bottom";
		position = "7 " @ (7+(30*(%gui.levelAmount-1)));
		extent = "50 18";
		minExtent = "8 2";
		visible = "1";
		lineSpacing = "2";
		maxChars = "-1";
		text = "<just:left><font:impact:18>Lvl" SPC %gui.levelAmount @ ":";
		maxBitmapHeight = "-1";
		selectable = "0";
	};
	%weapMenu = new GuiPopUpMenuCtrl(("GGO_Level" @ %gui.levelAmount)) {
		profile = "BlockButtonProfile";
        horizSizing = "right";
        vertSizing = "bottom";
		position = "54 " @ (6+(30*(%gui.levelAmount-1)));
		extent = "115 21";
		minExtent = "8 2";
		visible = "1";
		maxLength = "255";
		maxPopupHeight = "200";
	};
	%levelLevel = new GuiTextEditCtrl(("GGO_Level" @ %gui.levelAmount @ "Level")) {
		profile = "BlockTextEditProfile";
        horizSizing = "right";
        vertSizing = "bottom";
		position = "174 " @ (8+(30*(%gui.levelAmount-1)));
		extent = "24 18";
		minExtent = "8 2";
		visible = "1";
		command = "GGO_ValidateInt($ThisControl);";
		maxLength = "3";
	};
	("GGO_LevelSwatch").add(%levelName,%weapMenu,%levelLevel);
	refreshWeaponList(("GGO_Level" @ %gui.levelAmount));
}

function removeGunGameLevel() {
	%gui = GunGameOptionsMenu.getID();
	if(%gui.levelAmount < 2)
		return;
	%levelName = ("GGO_Level" @ %gui.levelAmount @ "Name").getID();
	%levelLevel = ("GGO_Level" @ %gui.levelAmount @ "Level").getID();
	%weapMenu = ("GGO_Level" @ %gui.levelAmount).getID();
	("GGO_LevelSwatch").remove(%levelName,%weapMenu,%levelLevel);
	("GGO_LevelSwatch").resize(1,1,205,(27+(30*(%gui.levelAmount-2))));
	%gui.levelAmount--;
}

function saveNameGGO() {
	%saveList = ("GGO_SaveList").getID();
	%saveName = ("GGO_SaveName").getID();
	if(%saveList.getValue() !$= "")
		%saveName.setValue(%saveList.getValue());
}

function refreshProfileList() {
	%saveList = ("GGO_SaveList").getID();
	%saveList.clear();
	%i=0;
	for(%file=findFirstFile("config/client/ggweaponprofiles/*.txt");isFile(%file);%file=findNextFile("config/client/ggweaponprofiles/*.txt")) {
		%list = strReplace(strReplace(%file,"config/client/ggweaponprofiles/",""), ".txt", "");
		%saveList.addRow(%i,%list);
		%i++;
	}
	%saveList.sort(0, 1);
}

function saveGunGameProfile() {
	%saveList = ("GGO_SaveList").getID();
	%saveName = ("GGO_SaveName").getID();
	%gui = ("GunGameOptionsMenu").getID();
	if(%saveName.getValue() $= "")
		return;
	%winningMethod = ("GGO_WinningMethod").getValue();
	if(%winningMethod $= "")
		%winningMethod = "First Kill";
	%knife = ("GGO_Knife").getValue();
	if(%knife $= "")
		%knife = "NONE";
	%levelSteal = ("GGO_LevelSteal").getValue();
	%grenade = ("GGO_Grenade").getValue();
	if(%grenade $= "")
		%grenade = "NONE";
	%returnTime = ("GGO_ReturnTime").getValue();
	%level1 = ("GGO_Level1").getValue();
	if(%level1 $= "")
		%level1 = "NONE";
	%file = new FileObject();
	%file.openForWrite("config/client/ggweaponprofiles/" @ %saveName.getValue() @ ".txt");
	if(!isFile("config/client/ggweaponprofiles/" @ %saveName.getValue() @ ".txt")) {
		error("Unable to create Gun Game Profile file!");
		%saveName.setValue("");
		return;
	}
	%file.writeLine("levelAmount" TAB %gui.levelAmount);
	%file.writeLine("winningMethod" TAB %winningMethod);
	%file.writeLine("pointLimit" TAB ("GGO_PointLimit").getValue());
	%file.writeLine("knife" TAB %knife);
	%file.writeLine("levelSteal" TAB %levelSteal);
	%file.writeLine("grenade" TAB %grenade);
	%file.writeLine("returnTime" TAB %returnTime);
	%file.writeLine(">Level" TAB "1");
	%file.writeLine("weapon" TAB %level1);
	for(%i=2;%i<=%gui.levelAmount;%i++) {
		%weapon = ("GGO_Level" @ %i).getValue();
		if(%weapon $= "")
			%weapon = "NONE";
		%val = ("GGO_Level" @ %i @ "Level").getValue();
		%file.writeLine(">Level" TAB %i);
		%file.writeLine("weapon" TAB %weapon);
		%file.writeLine("score" TAB %val);
	}
	%file.close();
	%file.delete();
	refreshProfileList();
}

function deleteGunGameProfile() {
	%saveList = ("GGO_SaveList").getID();
	if(%saveList.getValue() $= "" || !isFile("config/client/ggweaponprofiles/" @ %saveList.getValue() @ ".txt")) {
		refreshProfileList();
		return;
	}
	fileDelete("config/client/ggweaponprofiles/" @ %saveList.getValue() @ ".txt");
	refreshProfileList();
}

function checkGGTextRecolor() {
	%winningMethod = ("GGO_WinningMethod").getID();
	if(%winningMethod.getValue() $= "Point Limit") {
		("GGO_PointLimit").maxLength = 2;
		("GGO_PointLimitName").setText("<color:000000><font:Impact:18>Point Limit:");
	}
	else {
		("GGO_PointLimit").setText("");
		("GGO_PointLimit").maxLength = 0;
		("GGO_PointLimitName").setText("<color:CCCCCC><font:Impact:18>Point Limit:");
	}
	%knife = ("GGO_Knife").getID();
	if(%knife.getValue() $= "NONE") {
		("GGO_LevelSteal").setText("");
		("GGO_LevelSteal").maxLength = 0;
		("GGO_LevelStealName").setText("<color:CCCCCC><font:Impact:18>Level Steal:");
	}
	else {
		("GGO_LevelSteal").maxLength = 2;
		("GGO_LevelStealName").setText("<color:000000><font:Impact:18>Level Steal:");
	}
	%grenade = ("GGO_Grenade").getID();
	if(%grenade.getValue() $= "NONE") {
		("GGO_ReturnTime").setText("");
		("GGO_ReturnTime").maxLength = 0;
		("GGO_ReturnTimeName").setText("<color:CCCCCC><font:Impact:18>Return Time:");
	}
	else {
		("GGO_ReturnTime").maxLength = 2;
		("GGO_ReturnTimeName").setText("<color:000000><font:Impact:18>Return Time:");
	}
}

function GGO_ValidateInt(%ctrl) {
	%filter = strReplace(%ctrl.getValue(),"-","");
	%filter1 = strReplace(%filter," ","");
	%val = mFloatLength(%filter1,0);
	%ctrl.setValue(%val);
}

function GGO_ValidateRTInt(%ctrl) {
	%filter = strReplace(%ctrl.getValue(),"-","");
	%filter1 = strReplace(%filter," ","");
	%ctrl.setValue(%filter1);
}

function loadGunGameProfile() {
	%gui = ("GunGameOptionsMenu").getID();
	%saveList = ("GGO_SaveList").getValue();
	if(%saveList $= "" || !isFile("config/client/ggweaponprofiles/" @ %saveList @ ".txt"))
		return;
	%file = new FileObject();
	%file.openForRead("config/client/ggweaponprofiles/" @ %saveList @ ".txt");
	while(!%file.isEOF()) {
		%line = %file.readLine();
		%type = getField(%line,0);
		%val = getFields(%line,1,5);
		switch$(%type) {
			case "levelAmount": %levelAmount = %val;
			case "winningMethod": %winningMethod = %val;
			case "pointLimit": %pointLimit = %val;
			case "knife": %knife = %val;
			case "levelSteal": %levelSteal = %val;
			case "grenade": %grenade = %val;
			case "returnTime": %returnTime = %val;
			case ">Level": %currLevel = %val;
			case "weapon": %weapon[%currLevel] = %val;
			case "score": %score[%currLevel] = %val;
		}
	}
	while(%gui.levelAmount < %levelAmount) {
		if(%gui.levelAmount > 98)
			break;
		addGunGameLevel();
	}
	while(%gui.levelAmount > %levelAmount) {
		if(%gui.levelAmount < 2)
			break;
		removeGunGameLevel();
	}
	%weapMenu = ("GGO_Level1").getID();
	if(%weapMenu.itemID[%grenade] $= "")
		("GGO_Grenade").setValue("NONE");
	else
		("GGO_Grenade").setValue(%grenade);
	if(%weapMenu.itemid[%knife] $= "")
		("GGO_Knife").setValue("NONE");
	else
		("GGO_Knife").setValue(%knife);
	%wm = ("GGO_WinningMethod").getID();
	%wm.setValue(%winningMethod);
	checkGGTextRecolor();
	if(%wm.getValue() $= "Point Limit")
		("GGO_PointLimit").setValue(%pointLimit);
	else
		("GGO_PointLimit").setText("");
	if(%weapMenu.itemid[%weapon[1]] $= "")
		%weapMenu.setValue("NONE");
	else
		%weapMenu.setValue(%weapon[1]);
	for(%i=2;%i<=%gui.levelAmount;%i++) {
		%weapMenu = ("GGO_Level" @ %i).getID();
		if(%weapMenu.itemID[%weapon[%i]] $= "")
			%weapMenu.setValue("NONE");
		else
			%weapMenu.setValue(%weapon[%i]);
		("GGO_Level" @ %i @ "Level").setValue(%score[%i]);
	}
}

function startGunGame() {
	%gui = ("GunGameOptionsMenu").getID();
	%pointLimit = ("GGO_PointLimit").getValue();
	%winningMethod = ("GGO_WinningMethod").getValue();
	if(%winningMethod $= "Point Limit" && %pointLimit $= "") {
			messageBoxOk("Gun Game Options Menu","The Point Limit is not filled in!");
			return;
	}
	if(("GGO_Knife").getValue() !$= "NONE" && ("GGO_LevelSteal").getValue() $= "") {
		messageBoxOk("Gun Game Options Menu","The Level Steal box is not filled in!");
		return;
	}
	if(("GGO_Grenade").getValue() !$= "NONE" && ("GGO_ReturnTime").getValue() $= "") {
		messageBoxOk("Gun Game Options Menu","The Return Time box is not filled in!");
		return;
	}
	for(%i=2;%i<=%gui.levelAmount;%i++) {
		%levelLevel = ("GGO_Level" @ %i @ "Level").getValue();
		if(%levelLevel $= "") {
			messageBoxOk("Gun Game Options Menu","All of the level boxes are not filled in!");
			return;
		}
		%pastLevel = ("GGO_Level" @ (%i - 1) @ "Level").getValue();
		if(%levelLevel <= %pastLevel) {
			messageBoxOk("Gun Game Options Menu","The level boxes are incorrectly filled in!");
			return;
		}
		if(%winningMethod $= "Point Limit" && %levelLevel >= %pointLimit) {
			messageBoxOk("Gun Game Options Menu","The point limit is set lower than a level amount!");
			return;
		}
	}
	%knife = ("GGO_Knife").itemID[("GGO_Knife").getValue()];
	%grenade = ("GGO_Grenade").itemID[("GGO_Grenade").getValue()];
	commandToServer('GG_receiveInfo',%gui.levelAmount,("GGO_WinningMethod").getValue(),("GGO_PointLimit").getValue(),%knife,("GGO_LevelSteal").getValue(),%grenade,("GGO_ReturnTime").getValue());
	for(%i=1;%i<=%gui.levelAmount;%i++)
		commandToServer('GG_receiveLevelInfo',%i,("GGO_Level" @ %i).itemID[("GGO_Level" @ %i).getValue()],("GGO_Level" @ %i @ "Level").getValue());
	commandToServer('startGunGame');
	canvas.popDialog(%gui);
}

function stopGunGame() {
	commandToServer('stopGunGame');
}