function serverCmdgungameoptions(%client) {
	commandToClient(%client,'OpenGunGame');
}

function serverCmdGG_receiveInfo(%client,%levelAmount,%winningMethod,%pointLimit,%knife,%levelSteal,%grenade,%returnTime) {
	%minigame = %client.minigame;
	if(!isObject(%minigame) || %minigame.owner != %client)
		return;
	if(%levelAmount $= "" || %winningMethod $= "" || %knife $= "" || %grenade $= "")
		return;
	if(%winningMethod $= "Point Limit" && %pointLimit $= "")
		return;
	if(%knife !$= "NONE" && %levelSteal $= "")
		return;
	if(%grenade !$= "NONE" && %returnTime $= "")
		return;
	%minigame.levelAmount = %levelAmount;
	%minigame.winningMethod = %winningMethod;
	if(%winningMethod $= "Point Limit")
		%minigame.pointLimit = %pointLimit;
	%minigame.knife = %knife;
	if(%knife !$= "NONE")
		%minigame.levelSteal = %levelSteal;
	%minigame.grenade = %grenade;
	if(%grenade !$= "NONE")
		%minigame.returnTime = %returnTime;
	%minigame.ggInfoReceived = 1;
}

function serverCmdGG_receiveLevelInfo(%client,%levelNum,%item,%point) {
	%minigame = %client.minigame;
	if(!isObject(%minigame) || %minigame.owner != %client)
		return;
	if(%levelNum $= "" || %item $= "" || (%point $= "" && %levelNum != 1))
		return;
	%minigame.levelItem[%levelNum] = %item;
	if(%levelNum != 1)
		%minigame.levelPoint[%levelNum] = %point;
}

function ggReturnItem(%item,%player) {
	%player.tool[0] = %item;
	messageClient(%player.client ,'MsgItemPickup','',0,%item);
}

function serverCmdstartGunGame(%client) {
	%minigame = %client.minigame;
	if(!isObject(%minigame) || %minigame.owner != %client) {
		messageClient(%client,'',"\c0You do not have a minigame running.");
		return;
	}
	cancel(%minigame.startGunGame);
	%minigame.ggTimeout++;
	if(%minigame.ggTimeout > 15) {
		messageClient(%client,'chatMessage',"Unable to start Gun Game. Client timed out or incorrect information was sent.");
		return;
	}
	if(!%minigame.ggInfoReceived) {
		%minigame.startGunGame = schedule(100,0,'serverCmdstartGunGame',%client);
		return;
	}
	for(%i=1;%i<%minigame.levelAmount;%i++) {
		if(%i != 1) {
			if(%minigame.levelItem[%i] $= "" || %minigame.levelPoint[%i] $= "") {
				%minigame.startGunGame = schedule(100,0,'serverCmdstartGunGame',%client);
				return;
			}
			if(%minigame.levelPoint[%i] <= %minigame.levelPoint[%i-1]) {
				messageClient(%client,'chatMessage',"Bad information was received. Gun Game cannot start.");
				return;
			}
		}
		else {
			if(%minigame.levelItem[%i] $= "") {
				%minigame.startGunGame = schedule(100,0,'serverCmdstartGunGame',%client);
				return;
			}
		}
		if(%minigame.winningMethod $= "Point Limit" && %minigame.levelPoint[%i] >= %minigame.pointLimit) {
			messageClient(%client,'chatMessage',"Bad information was received. Gun Game cannot start.");
			return;
		}
	}
	if(%minigame.grenade $= "NONE") {
		%path = ("config/server/gungameoptions/" @ %client.getBLID() @ ".cs");
		if(isPackage("GunGameWeapon_" @ %client.getBLID()))
			deactivatePackage("GunGameWeapon_" @ %client.getBLID());
		%file = new FileObject();
		%file.openForWrite(%path);
		%file.writeLine("package" SPC "GunGameWeapon_" @ %client.getBLID() SPC "{");
		%file.writeLine("	function" SPC %minigame.grenade.image @ "::onFire(%this,%obj,%slot) {");
		%file.writeLine("		Parent::onFire(%this,%obj,%slot);");
		%file.writeLine("		if(%obj.client.minigame.isGunGame && %obj.client.minigame.grenade.image == %this) {");
		%file.writeLine("			%item =" SPC %minigame.grenade.getID() @ ";");
		%file.writeLine("			%obj.schedule(%obj.client.minigame.returnTime*1000,'ggReturnItem',%item,%obj);");
		%file.writeLine("		}");
		%file.writeLine("	}");
		%file.writeLine("};");
		%file.writeLine("activatePackage(GunGameWeapon_" @ %client.getBLID() @ ");");
		%file.close();
		%file.delete();
		exec(%path);
	}
	%minigame.ggTimeout = "";
	%minigame.reset(%client);
	%minigame.isGunGame = 1;
}

function serverCmdstopGunGame(%client,%reset) {
	if(!isObject(%client.minigame) || %client.minigame.owner != %client || !%client.minigame.isGunGame) {
		messageClient(%client,'',"\c0You do not have a Gun Game running.");
		return;
	}
	if(!%reset)
		%client.minigame.reset(%client);
	deactivatePackage("GunGameWeapon_" @ %client.getBLID());
	fileDelete("config/server/gungameoptions/" @ %client.getBLID() @ ".cs");
	%client.minigame.isGunGame = 0;
	for(%i=0;%i<%client.minigame.numMembers;%i++)
		commandToClient(%client.minigame.member[%i],'ClearBottomPrint');
}

function declareGunGameWinner(%client,%minigame) {
	%minigame.messageAll('',"\c3" @ %client.name @ "\c6 has won this round!");
	%count = %minigame.numMembers;
	for(%i=0;%i<%count;%i++) {
		%client1 = %minigame.member[%i];
		if(isObject(%client1.player)) {
			%client1.setControlObject(%client1.camera);
			%client1.camera.setMode("Corpse",%client1.player);
			%client1.play2d(rewardSound);
		}
		else {
			%client1.getAutoCameraTarget();
			%client1.play2d(rewardSound);
		}
	}
	%minigame.schedule(5000,reset,%minigame.owner);
}

function getCurrentGGLevel(%client,%minigame) {
	for(%i=2;%i<=%minigame.levelAmount;%i++) {
		if(%client.score < %minigame.levelPoint[%i])
			return (%i - 1);
	}
	if(%client.score > %minigame.levelPoint[%minigame.levelAmount])
		return %minigame.levelAmount;
	return -1;
}

function getHighestGGLevel(%minigame) {
	%highestScore = getCurrentGGLevel(%minigame.member0,%minigame);
	for(%i=0;%i<%minigame.numMembers;%i++) {
		%client = %minigame.member[%i];
		if(getCurrentGGLevel(%client,%minigame) > %highestScore)
			%highestScore = getCurrentGGLevel(%client,%minigame);
	}
	return %highestScore;
}

package GunGame {
	function serverCmdEndMinigame(%client) {
		serverCmdstopGunGame(%client,1);
		Parent::EndMiniGame(%client);
	}

	function gameConnection::setScore(%client,%score) {
		Parent::setScore(%client,%score);
		%minigame = %client.minigame;
		if(!%minigame.isGunGame || !isObject(%minigame))
			return;
		if(%minigame.winningMethod $= "Point Limit" && %client.score >= %minigame.pointLimit) {
			declareGunGameWinner(%client,%minigame);
			return;
		}
		if(%minigame.winningMethod $= "First Kill" && %client.ggFirstKill) {
			declareGunGameWinner(%client,%minigame);
			%client.ggFirstKill = 0;
			return;
		}
		%level = getCurrentGGLevel(%client,%minigame);
		if(%minigame.winningMethod $= "First Kill" && %level >= %minigame.levelAmount)
			%client.ggFirstKill = 1;
		if(%client.player.tool[0] != %minigame.levelItem[%level]) {
			%weapon = %minigame.levelItem[%level];
			if(!isObject(%weapon)) {
				%client.player.tool[0] = 0;
				messageClient(%client,'MsgItemPickup','',0,0);
			}
			else {
				%client.player.tool[0] = %weapon;
				messageClient(%client,'MsgItemPickup','',0,%weapon);
			}
		}
		%highestLevel = getHighestGGLevel(%minigame);
		if(%level == %highestLevel) {
			for(%i=0;%i<%minigame.numMembers;%i++)
				commandToClient(%minigame.member[%i],'BottomPrint',"<font:impact:24>\c6You are at level\c3 " @ %level @ "\c6. The leader is at level\c3 " @ %highestLevel @ "\c6.",-1);
		}
		else
			commandToClient(%client,'BottomPrint',"<font:impact:24>\c6You are at level\c3 " @ %level @ "\c6. The leader is at level\c3 " @ %highestLevel @ "\c6.",-1);
	}

	function gameConnection::spawnPlayer(%client) {
		Parent::spawnPlayer(%client);
		%client.setScore(%client.score);
	}

	function MinigameSO::displayScoresList(%this) {
		echo("Score display bypassed!");
	}

	function gameConnection::onDeath(%client,%killer,%killerClient,%damageType,%body) {
		Parent::onDeath(%client,%killer,%killerClient,%damageType,%body);
		if(isObject(%client.minigame) && %client.minigame.isGunGame && %client.minigame.knife !$= "") {
			if(%killer.getMountedImage(0) == %client.minigame.knife.image)  {
				%clientLevel = getCurrentGGLevel(%client,%client.minigame);
				%killerLevel = getCurrentGGLevel(%killerClient,%killerClient.minigame);
				if((%client.score - %client.minigame.levelSteal) <= 0) {
					%client.setScore(0);
					%killerClient.setScore(%killerClient.minigame.levelPoint[(%killerLevel + %killerClient.minigame.levelSteal)]);
				}
				else {
					%client.setScore(%client.minigame.levelPoint[(%clientLevel - %client.minigame.levelSteal)]);
					%killerClient.setScore(%killerClient.minigame.levelPoint[(%killerLevel + %killerClient.minigame.levelSteal)]);
				}
			}
		}
	}
};
activatePackage(GunGame);